/*********************************************************************************
**
**   $Id: custvehcselect.ui.h,v 1.7 2004/07/10 14:06:51 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include "customerselect.h"
#include "customerentry.h"
#include "vehcedit.h"

void CustVehcSelect::newCustomer()
{
   QString customer;
   int icust, ivehc;

   CustomerEntry *ce = new CustomerEntry(this);
   ce->initialize();
   icust = ce->exec();
   printf("CustVehcSelect::newCustomer(): customer selected = %d\n", icust);
   if ( icust > 1 ) 
   {
      customer.setNum(icust);
/*
      VehcEdit *ve = new VehcEdit(this);
      ve->setOwner(customer);
      ve->initialize();
      ivehc = ve->exec();
      printf("CustVehcSelect::newCustomer(): vehicle selected = %d\n", ivehc);
      done(ivehc);
      delete ve;
*/
   }
   delete ce;
   vehicleTable->refresh();
}

void CustVehcSelect::newVehicle()
{
   QString customer;
   printf("CustVehcSelect::newVehicle(): Enter\n");
   fflush(stdout);
   CustomerSelect *cs = new CustomerSelect(this);
   customer.setNum(cs->exec());
   if ( customer.toInt() > 0 ) 
   {
      VehcEdit *ve = new VehcEdit(this);
      ve->setOwner(customer);
      ve->initialize();
      int v = ve->exec();
      printf("CustVehcSelect::newVehicle(): vehicle selected = %d\n", v);
      fflush(stdout);
      done(v);
      printf("CustVehcSelect::newVehicle(): deleting VehcEdit dialog\n");
      fflush(stdout);
      delete ve;
   }
   printf("CustVehcSelect::newVehicle(): deleting CustomerSelect dialog\n");
   fflush(stdout);
   delete cs;
   vehicleTable->refresh();
   printf("CustVehcSelect::newVehicle(): Exit\n");
   fflush(stdout);
}


void CustVehcSelect::selectVehicle()
{
   QSqlRecord *r = vehicleTable->currentRecord();
   done(r->value("ident").toInt());
}


void CustVehcSelect::newRetail()
{
   done(1);
}

void CustVehcSelect::filterByName()
{
   QString s, s1;
   s1 = FilterEdit->text().lower();
   s1.replace('\'', "''");
   s = "lower(owner) like '%" + s1 + "%'";
   vehicleTable->setFilter(s);
   vehicleTable->refresh();
}


void CustVehcSelect::filterByTag()
{
   QString s, s1;
   s1 = FilterEdit->text().lower();
   s1.replace('\'', "''");
   s = "lower(tag) like '%" + s1 + "%'";
   vehicleTable->setFilter(s);
   vehicleTable->refresh();
}


void CustVehcSelect::filterByVIN()
{
   QString s, s1;
   s1 = FilterEdit->text().lower();
   s1.replace('\'', "''");
   s = "lower(vin) like '%" + s1 + "%'";
   vehicleTable->setFilter(s);
   vehicleTable->refresh();
}


void CustVehcSelect::clearFilter()
{
   QString s;
   s = "";
   vehicleTable->setFilter(s);
   vehicleTable->refresh();
}



