/*********************************************************************************
**
**   $Id: movetransactions.ui.h,v 1.3 2004/04/03 14:04:53 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qmessagebox.h>
#include <qsettings.h>
#include <qsqldatabase.h>
#include <qsqlquery.h>

extern QSqlDatabase *autohouse;
extern QSettings Config;

void MoveTransactions::moveTransactions()
{
   QString sBank, sHazMatAcct, sLaborAcct, sPartsAcct, sSalesTaxAcct, sVendor, sVendorsAcct;

   sHazMatAcct.setNum(hazmatAcctSelect->getAccount());
   sLaborAcct.setNum(laborAcctSelect->getAccount());
   sPartsAcct.setNum(partsAcctSelect->getAccount());
   sSalesTaxAcct.setNum(salestaxAcctSelect->getAccount());
   sVendorsAcct.setNum(vendorsAcctSelect->getAccount());
   sVendor.setNum(selfVendor->getVendor());
   sBank.setNum(bankVendor->getVendor());

   QString sql = "select ident, parts, labor, tax, hazmat, total, date_out from workorders where date_out >= '"  + dateEdit1->date().toString("MM/dd/yyyy") +
         "' and date_out <= '" + dateEdit2->date().toString("MM/dd/yyyy") + "' and closed = 'Y' and recorded = 'N'";
   printf("MoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q1(sql);
   if (q1.isActive()) 
   {
      while (q1.next()) 
      {
         QString ident = q1.value(0).asString();
         QString parts = q1.value(1).asString();
         QString labor = q1.value(2).asString();
         QString tax   = q1.value(3).asString();
         QString hazmat = q1.value(4).asString();
         QString total = q1.value(5).asString();
         QDate d = q1.value(6).asDate();
         QString date_out = d.toString("MM/dd/yyyy");
         autohouse->transaction();
         QString description = "Invoice for Workorder " + ident;
         sql = "insert into ledger (descr, type, mult, date_in, vendor, account, amount) values ('" + 
                     description + "', 'DB', '-1', '" +
                     date_out + "', '" +
                     sBank + "', '" +
                     sVendorsAcct + "', '" +
                     total + "')";
         printf("\n\nMoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
         QSqlQuery q2;
         q2.exec(sql);
         if ( q2.isActive() ) 
         {
            printf("MoveTransactions::moveTransactions(): parts = %f\n", parts.toFloat());
            if ( parts.toFloat() > 0.0 ) 
            {
               sql = "insert into ledger (descr, type, mult, date_in, vendor, account, amount) values ('" + 
                           description + "', 'CR', '1', '" +
                           date_out + "', '" +
                           sVendor + "', '" +
                           sPartsAcct + "', '" +
                           parts + "')";
               printf("MoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
               q2.exec(sql);
               if ( ! q2.isActive() ) 
               {
                  QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                              "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
                  int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
                  autohouse->rollback();
                  if ( btn == QMessageBox::Cancel ) 
                  {
                     break;
                  }
                  continue;
               }
                  
            }
            printf("MoveTransactions::moveTransactions(): labor = %f\n", labor.toFloat());
            if ( labor.toFloat() > 0.0 ) 
            {
               sql = "insert into ledger (descr, type, mult, date_in, vendor, account, amount) values ('" + 
                           description + "', 'CR', '1', '" +
                           date_out + "', '" +
                           sVendor + "', '" +
                           sLaborAcct + "', '" +
                           labor + "')";
               q2.exec(sql);
               printf("MoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
               if ( ! q2.isActive() ) 
               {
                  QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                              "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
                  int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
                  autohouse->rollback();
                  if ( btn == QMessageBox::Cancel ) 
                  {
                     break;
                  }
                  continue;
               }
            }
            printf("MoveTransactions::moveTransactions(): hazmat = %f\n", hazmat.toFloat());
            if ( hazmat.toFloat() > 0.0 ) 
            {
               sql = "insert into ledger (descr, type, mult, date_in, vendor, account, amount) values ('" + 
                           description + "', 'CR', '1', '" +
                           date_out + "', '" +
                           sVendor + "', '" +
                           sHazMatAcct + "', '" +
                           hazmat + "')";
               printf("MoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
               q2.exec(sql);
               if ( ! q2.isActive() ) 
               {
                  QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                              "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
                  int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
                  autohouse->rollback();
                  if ( btn == QMessageBox::Cancel ) 
                  {
                     break;
                  }
                  continue;
               }
                  
            }
            printf("MoveTransactions::moveTransactions(): tax = %f\n", tax.toFloat());
            if ( tax.toFloat() > 0.0 ) 
            {
               sql = "insert into ledger (descr, type, mult, date_in, vendor, account, amount) values ('" + 
                           description + "', 'CR', '1', '" +
                           date_out + "', '" +
                           sVendor + "', '" +
                           sSalesTaxAcct + "', '" +
                           tax + "')";
               printf("MoveTransactions::moveTransactions(): sql = |%s|\n", (const char*)sql);
               q2.exec(sql);
               if ( ! q2.isActive() ) 
               {
                  QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                              "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
                  int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
                  autohouse->rollback();
                  if ( btn == QMessageBox::Cancel ) 
                  {
                     break;
                  }
                  continue;
               }
            }
            sql = "update workorders set recorded = 'Y' where ident = '" + ident + "'";
            q2.exec(sql);
            if ( ! q2.isActive() ) 
            {
               QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                           "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
               int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
               autohouse->rollback();
               if ( btn == QMessageBox::Cancel ) 
               {
                  break;
               }
               continue;
            }
            else
            {
               autohouse->commit();
            }
         }
         else
         {
            QString s = "The following error occured while moving this transaction:<br>" + q2.lastError().databaseText() +
                        "<br>This transaction will be skipped<br>Press Cancel to quit moving transactions entirely";
            int btn = QMessageBox::warning(NULL, "Error processing transaction", s, QMessageBox::Ok, QMessageBox::Cancel);
            autohouse->rollback();
            if ( btn == QMessageBox::Cancel ) 
            {
               break;
            }
            continue;
         }
         fflush(stdout);
      }
   }
/*
*/
   Config.writeEntry("/CroftJ/AutoHouse/HazMatAccount", sHazMatAcct);
   Config.writeEntry("/CroftJ/AutoHouse/LaborAccount", sLaborAcct);
   Config.writeEntry("/CroftJ/AutoHouse/PartsAccount", sPartsAcct);
   Config.writeEntry("/CroftJ/AutoHouse/SalesTaxAccount", sSalesTaxAcct);
   Config.writeEntry("/CroftJ/AutoHouse/SelfVendor", sVendor);
   Config.writeEntry("/CroftJ/AutoHouse/SelfsAccount", sVendorsAcct);
   Config.writeEntry("/CroftJ/AutoHouse/BankVendor", sBank);
   accept();
}


void MoveTransactions::init()
{
   QString sHazMatAcct, sLaborAcct, sPartsAcct, sSalesTaxAcct, sVendor, sVendorsAcct, sBank;
   QString sql = "select min(date_out), max(date_out) from workorders where recorded='N' and closed='Y'";
   printf("MoveTransaction::init(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q(sql);
   if (q.isActive())
   {
      if (q.next()) 
      {
         dateEdit1->setDate(q.value(0).asDate());
         dateEdit2->setDate(q.value(1).asDate());
      }
   }
   sHazMatAcct = Config.readEntry("/CroftJ/AutoHouse/HazMatAccount");
   hazmatAcctSelect->setAccount(sHazMatAcct.toInt());
   sLaborAcct = Config.readEntry("/CroftJ/AutoHouse/LaborAccount");
   laborAcctSelect->setAccount(sLaborAcct.toInt());
   sPartsAcct = Config.readEntry("/CroftJ/AutoHouse/PartsAccount");
   partsAcctSelect->setAccount(sPartsAcct.toInt());
   sSalesTaxAcct = Config.readEntry("/CroftJ/AutoHouse/SalesTaxAccount");
   salestaxAcctSelect->setAccount(sSalesTaxAcct.toInt());
   sVendorsAcct = Config.readEntry("/CroftJ/AutoHouse/VendorsAccount");
   vendorsAcctSelect->setAccount(sVendorsAcct.toInt());
   sVendor = Config.readEntry("/CroftJ/AutoHouse/Vendor");
   selfVendor->setVendor(sVendor.toInt());
   sBank = Config.readEntry("/CroftJ/AutoHouse/Bank");
   bankVendor->setVendor(sBank.toInt());
}
